<?php
/* 
- - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
Title : 		Class: cDatabase
Author : 		Ryan Campbell
URL : 		http://particletree.com

Description : 	Class created to handle database operations.

Created : 		08/16/2005
Modified : 		08/16/2005
- - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
*/
class cDatabase {

	private $host;
	private $user;
	private $password;
	private $databaseName;
  
  	/*
	  *	Summary:	Common constructor
	  *	Parameters:	4 strings representing the data needed to build the connection
	  */
	function __construct($hostName, $userName, $passwordName, $databaseName){
		$this->host = $hostName;
		$this->user = $userName;
		$this->password = $passwordName;
		$this->databaseName = $databaseName;
	}

	/*
	  *	Summary:	INSERT into the database by looping through name / value paired arrays and
	  *			building the SQL statement
	  *	Parameters:	array of field names | array of values to insert into fields | table to insert into
	  */
	function sqlInsert($dataNames, $dataValues, $tableName){
		$sqlValues = "";
		$sqlNames = "INSERT INTO " . $tableName . "(";
		for($x = 0; $x < count($dataNames); $x++) {
			if($x != (count($dataNames) - 1)) {
				$sqlNames = $sqlNames . $dataNames[$x] . ", ";
				$sqlValues = $sqlValues . "'" . $dataValues[$x] . "', ";
			}
			else {
				$sqlNames = $sqlNames . $dataNames[$x] . ") VALUES(";
				$sqlValues = $sqlValues . "'" . $dataValues[$x] . "')";
			}
		}
		return $this->ExecuteNonQuery($sqlNames . $sqlValues);
	}

	/*
	  *	Summary:	UPDATE the database by looping through name / value paired arrays and
	  *			building the SQL statement
	  *	Parameters:	array of field names | array of values to insert into fields | table to insert into | sql WHERE condition
	  */
	function sqlUpdate($dataNames, $dataValues, $tableName, $condition){
		$sql = "UPDATE " . $tableName . " SET ";
		for($x = 0; $x < count($dataNames); $x++) {
			if($x != (count($dataNames) - 1)) {
				$sql = $sql . $dataNames[$x] . "= '" . $dataValues[$x] . "', ";
			}
			else {
				$sql = $sql . $dataNames[$x] . "= '" . $dataValues[$x] . "' ";
			}
		}
		$sql = $sql . $condition;
		echo $sql;
		$this->ExecuteNonQuery($sql);
	}

	/*
	  *	Summary:	Execute a properly formatted sql statement
	  *	Parameters:	sql statement
	  */
	function ExecuteNonQuery($sql){
		$conn = mysql_connect($this->host, $this->user, $this->password);
		mysql_select_db ($this->databaseName);
		$rs = mysql_query($sql,$conn);
		$ret = mysql_insert_id();
		settype($rs, "null");
		mysql_close($conn);
		return $ret;
	}
  
	/*
	  *	Summary:	Execute a properly formatted sql statement
	  *	Parameters:	sql statement
	  *	Return:	recordset containing the data from the query
	  */
	function ExecuteReader($query){
		$conn = mysql_connect($this->host, $this->user, $this->password);
		mysql_select_db($this->databaseName);
		$rs = mysql_query($query,$conn);
		mysql_close($conn);
		return $rs;
	} 
	
	/*
	  *	Summary:	Take data from database and write it as an XML file
	  *			http://www.tonymarston.net/php-mysql/dom.html
	  *	Parameters:	recordset | string to name top node | string to name sub nodes
	  *	Return:	String containing properly formatted XML
	  */
	function ConvertRStoXML($rs, $topLevelNodeName, $rowNodeName) {
		$doc = new DomDocument('1.0');
		$root = $doc->createElement($topLevelNodeName);
		$root = $doc->appendChild($root);
		while ($row = @mysql_fetch_array($rs, MYSQL_ASSOC)) {
			$node = $doc->createElement($rowNodeName);
			$node = $root->appendChild($node);
			foreach ($row as $fieldname => $fieldvalue) {
				$child = $doc->createElement($fieldname);
				$child = $node->appendChild($child);
				$value = $doc->createTextNode($fieldvalue);
				$value = $child->appendChild($value);
			}
		}
		$xml_string = $doc->saveXML();
		return $xml_string;
	}
}
?>